﻿#!/usr/bin/env python
# -*- coding: utf-8 -*-
from direct.gui.OnscreenText import OnscreenText

import direct.directbase.DirectStart
from direct.showbase.DirectObject import DirectObject
from pandac.PandaModules import *

from modules.camera import CamFree
kamera = CamFree()

textinfo = OnscreenText(pos = (-0.5, 0.9), scale = 0.1)
textinfo.hide()

# обработка колизий или кликов по объектам #
CurPicker = CollisionTraverser() #Создание конвейра
CurPickerOr = CollisionHandlerQueue() #Очередь столкновений
CurPickerNod = CollisionNode('mouseRay') #нод для луча
CurPickerCam = camera.attachNewNode(CurPickerNod) #закрепляем нод на камере
CurPickerNod.setFromCollideMask(BitMask32.bit(1)) # устанавливаем маску
CurPickerNod.setIntoCollideMask(BitMask32.allOff()) # отключаем проверку колииззии с иными масками
CurPickerRay = CollisionRay() #Создаём луч
CurPickerNod.addSolid(CurPickerRay) #прикрепляем луч к ноду
CurPicker.addCollider(CurPickerCam, CurPickerOr) # вносим в конвеер

def Load(): #Функция загрузки объектов
    Object = loader.loadModel("sphere\sphere") # загружаем модель
    ModelNode = render.attachNewNode('sphere0') # Создаём нод в рендере сцены и назначаем имя и номер.
    ModelNode.setTag('name' , 'Sun') # Устанавливаем имя планеты
    Object.reparentTo(ModelNode) # Прицепляем модель к ноду
    ModelNode.setPos(0, 50, 0) # Устанавливаем координаты
    ModelNode.setCollideMask(BitMask32.bit(1)) # Устанавливаем ноду маску как у луча.
    
    
    Object1 = loader.loadModel("sphere\sphere") # загружаем модель
    ModelNode1 = render.attachNewNode('sphere1') # Создаём нод в рендере сцены и назначаем имя и номер.
    ModelNode1.setTag('name' , 'Moon') # Устанавливаем имя планеты
    Object1.reparentTo(ModelNode1) # Прицепляем модель к ноду
    ModelNode1.setPos(55, 50, 0) # Устанавливаем координаты
    ModelNode1.setCollideMask(BitMask32.bit(1)) # Устанавливаем ноду маску как у луча.
    
Load()
    
def Pick():
    if base.mouseWatcherNode.hasMouse(): # делаем проверку в окне ли курсор(мышь).
        pass # пас ниже.
    mpos = base.mouseWatcherNode.getMouse() # получаем координаты курсора.
    CurPickerRay.setFromLens(base.camNode, mpos.getX(), mpos.getY()) # уставливаем их лучу.
    CurPicker.traverse(render) # запуск проверки коллизий(луча с объектами).
    CurPickerOr.sortEntries() # сортируем что бы получить ближний объект.
    if (CurPickerOr.getNumEntries() > 0): # проверяем есть ли пересечения луча с полигонами объекта.
        info = CurPickerOr.getEntry(0) # получаем информацию по первому полигону.
        info1 = info.getIntoNodePath() # выбираем информацию имя нода, имя модели, т.д.
        PathSimul = str(info1) # переводим инфо в строку.
        translite1 = PathSimul.split('/') # разделяем слэшами и получаем список.
        
        node = render.find("**/"+str(translite1[1])) # Ищем в рендере узел с именем
        textinfo.setText('Name: '+node.getTag('name')+'; Position: '+str(node.getPos()[0])+' '+str(node.getPos()[1])+' '+str(node.getPos()[2])) # Выбираем имя планеты и выводим его имя на экран.
        textinfo.show() # Отоброжаем текст с информацией.
            
    else:
        textinfo.hide() # Скрываем текст с информацией.
            
base.accept('mouse1',Pick) # событие нажатия кнопки мыши и запуск функции Pick.

run()
